#include <stdio.h>
void main()
{
	unsigned int a, b;
	char i, prekid;
	do
	{
		printf("Unesite broj A: ");
		scanf("%d", &a);
		printf("Unesite broj B (izmedju 0 i 7): ");
		do /* Ova petlja proverava da li je broj B izmedju 0 i 7 i izvrsava se dok god se ne unese ispravna vrednost */
		{
			scanf("%d", &b);
			if(b<0 || b>7)
				printf("Neispravan unos broja B. Ponovite unos: ");
		}while(b<0 || b>7);
		/* Prikazivanje broja A u binarnom obliku */
		printf ("Binarni oblik broja A:");
		for (i=0; i<32; i++)
		{
			if (i%4==0) printf (" ");
			printf ("%d", ((a<<i)&0x80000000)>> 31);
		}
		/******************************************/
		printf("\nHeksadecimalni oblik: %x\nDekadni oblik: %d", a, a); 
		/* "%x" je standardna izlazna konverzija za ispis broja u heksadecimalnom brojnom sistemu */
		printf("\nCiklicki pomeren broj:");
		for (i=0; i<b; i++)
		{
			if (!(a%2)) a=a>>1;
			else a=((a>>1)|0x80000000);
		}
		for (i=0; i<32; i++)
		{
			if (i%4==0) printf (" ");
			printf ("%d", ((a<<i)&0x80000000)>> 31);
		}
		getchar();
		printf("\nUnesite P(p) za prekid programa: ");
		scanf("%c", &prekid);
	}while(prekid!='P' && prekid!='p');
}

/* Objasnjenje dela koda koji ciklicki pomera broj A za B mesta u desno */
/* posto u zadatku kaze da se broj mora ciklicki pomeriti za B mesta zato
je i ubacena petlja FOR koja radi tacno B puta. Odnosno prilikom svakog
prolaska kroz petlju broj se pomera za jedno mesto u desno a na prvo binarno
polje u broju se upisuje NULA. Zbog toga se proverava da li je broj deljiv
sa 2. Ako nije znaci da se binarni oblik tog broja zavrsava 1, pa posle
pomeranja broja u desno na njegov pocetak treba upisati 1(tu jedinicu sa pocetka).
to se obavlja pomocu ovog dela |0x80000000 posto je binarni oblik ovog broja:
"10000000...0000", sto znaci da ce se promeniti samo prvi bit, dok ce
svi ostali ostati kakvi su bili do tada.*/